



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>android之ViewStub的使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">android之ViewStub的使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 15:16:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>转自http://blog.csdn.net/hitlion2008/article/details/6737537</p>
<p>在开发应用程序的时候，经常会遇到这样的情况，会在运行时动态根据条件来决定显示哪个View或某个布局。那么最通常的想法就是把可能用到的View都写在上面，先把它们的可见性都设为View.<em>GONE</em>，然后在代码中动态的更改它的可见性。这样的做法的优点是逻辑简单而且控制起来比较灵活。但是它的缺点就是，耗费资源。虽然把View的初始可见View.<em>GONE</em>但是在Inflate布局的时候View仍然会被Inflate，也就是说仍然会创建对象，会被实例化，会被设置属性。也就是说，会耗费内存等资源。</p>
<p>推荐的做法是使用<em>android.view.ViewStub</em>，ViewStub 是一个轻量级的View，它一个看不见的，不占布局位置，占用资源非常小的控件。可以为ViewStub指定一个布局，在Inflate布局的时候，只有 ViewStub会被初始化，然后当ViewStub被设置为可见的时候，或是调用了ViewStub.inflate()的时候，ViewStub所向 的布局就会被Inflate和实例化，然后ViewStub的布局属性都会传给它所指向的布局。这样，就可以使用ViewStub来方便的在运行时，要还 是不要显示某个布局。</p>
<p>但ViewStub也不是万能的，下面总结下ViewStub能做的事儿和什么时候该用ViewStub，什么时候该用可见性的控制。</p>
<p>首先来说说ViewStub的一些特点：</p>
<p>1. ViewStub只能Inflate一次，之后ViewStub对象会被置为空。按句话说，某个被ViewStub指定的布局被Inflate后，就不会够再通过ViewStub来控制它了。</p>
<p>2. ViewStub只能用来Inflate一个布局文件，而不是某个具体的View，当然也可以把View写在某个布局文件中。</p>
<p>基于以上的特点，那么可以考虑使用ViewStub的情况有：</p>
<p>1. 在程序的运行期间，某个布局在Inflate后，就不会有变化，除非重新启动。</p>
<p>因为ViewStub只能Inflate一次，之后会被置空，所以无法指望后面接着使用ViewStub来控制布局。所以当需要在运行时不止一次的显示和<br />
隐藏某个布局，那么ViewStub是做不到的。这时就只能使用View的可见性来控制了。</p>
<p>2. 想要控制显示与隐藏的是一个布局文件，而非某个View。</p>
<p>因为设置给ViewStub的只能是某个布局文件的Id，所以无法让它来控制某个View。</p>
<p>所以，如果想要控制某个View(如Button或TextView)的显示与隐藏，或者想要在运行时不断的显示与隐藏某个布局或View，只能使用View的可见性来控制。</p>
<p>下面来看一个实例</p>
<p>在这个例子中，要显示二种不同的布局，一个是用TextView显示一段文字，另一个则是用ImageView显示一个图片。这二个是在onCreate()时决定是显示哪一个，这里就是应用ViewStub的最佳地点。</p>
<p>先来看看布局，一个是主布局，里面只定义二个ViewStub，一个用来控制TextView一个用来控制ImageView，另外就是一个是为显示文字的做的TextView布局，一个是为ImageView而做的布局：</p>
<div>
<ol><li>&lt;?xml&nbsp;version="1.0"&nbsp;encoding="utf-8"?&gt;</li>
<li>&lt;LinearLayout</li>
<li>xmlns:android="http://schemas.android.com/apk/res/android"</li>
<li>android:orientation="vertical"</li>
<li>android:layout_width="fill_parent"</li>
<li>android:layout_height="fill_parent"</li>
<li>android:gravity="center_horizontal"&gt;</li>
<li>&lt;ViewStub</li>
<li>android:id="@+id/viewstub_demo_text"</li>
<li>android:layout_width="wrap_content"</li>
<li>android:layout_height="wrap_content"</li>
<li>android:layout_marginLeft="5dip"</li>
<li>android:layout_marginRight="5dip"</li>
<li>android:layout_marginTop="10dip"</li>
<li>android:layout="@layout/viewstub_demo_text_layout"/&gt;</li>
<li>&lt;ViewStub</li>
<li>android:id="@+id/viewstub_demo_image"</li>
<li>android:layout_width="wrap_content"</li>
<li>android:layout_height="wrap_content"</li>
<li>android:layout_marginLeft="5dip"</li>
<li>android:layout_marginRight="5dip"</li>
<li>android:layout="@layout/viewstub_demo_image_layout"/&gt;</li>
<li>&lt;/LinearLayout&gt;</li></ol>
</div>
<p>为TextView的布局：</p>
<div>
<ol><li>&lt;?xml&nbsp;version="1.0"&nbsp;encoding="utf-8"?&gt;</li>
<li>&lt;LinearLayout</li>
<li>xmlns:android="http://schemas.android.com/apk/res/android"</li>
<li>android:orientation="vertical"</li>
<li>android:layout_width="wrap_content"</li>
<li>android:layout_height="wrap_content"&gt;</li>
<li>&lt;TextView</li>
<li>android:id="@+id/viewstub_demo_textview"</li>
<li>android:layout_width="fill_parent"</li>
<li>android:layout_height="wrap_content"</li>
<li>android:background="#aa664411"</li>
<li>android:textSize="16sp"/&gt;</li>
<li>&lt;/LinearLayout&gt;</li></ol>
</div>
<p>为ImageView的布局：</p>
<div>
<ol><li>&lt;?xml&nbsp;version="1.0"&nbsp;encoding="utf-8"?&gt;</li>
<li>&lt;LinearLayout</li>
<li>xmlns:android="http://schemas.android.com/apk/res/android"</li>
<li>android:orientation="vertical"</li>
<li>android:layout_width="wrap_content"</li>
<li>android:layout_height="wrap_content"&gt;</li>
<li>&lt;ImageView</li>
<li>android:id="@+id/viewstub_demo_imageview"</li>
<li>android:layout_width="wrap_content"</li>
<li>android:layout_height="wrap_content"/&gt;</li>
<li>&lt;/LinearLayout&gt;</li></ol>
</div>
<p>下面来看代码，决定来显示哪一个，只需要找到相应的ViewStub然后调用其infalte()就可以获得相应想要的布局：</p>
<div>
<ol><li>package&nbsp;com.effective;</li>
<li>import&nbsp;android.app.Activity;</li>
<li>import&nbsp;android.os.Bundle;</li>
<li>import&nbsp;android.view.ViewStub;</li>
<li>import&nbsp;android.widget.ImageView;</li>
<li>import&nbsp;android.widget.TextView;</li>
<li>public&nbsp;class&nbsp;ViewStubDemoActivity&nbsp;extends&nbsp;Activity&nbsp;{</li>
<li>@Override</li>
<li>public&nbsp;void&nbsp;onCreate(Bundle&nbsp;savedInstanceState)&nbsp;{</li>
<li>super.onCreate(savedInstanceState);</li>
<li>setContentView(R.layout.viewstub_demo_activity);</li>
<li>if&nbsp;((((int)&nbsp;(Math.random()&nbsp;*&nbsp;100))&nbsp;&amp;&nbsp;0x01)&nbsp;==&nbsp;0)&nbsp;{</li>
<li>//&nbsp;to&nbsp;show&nbsp;text</li>
<li>//&nbsp;all&nbsp;you&nbsp;have&nbsp;to&nbsp;do&nbsp;is&nbsp;inflate&nbsp;the&nbsp;ViewStub&nbsp;for&nbsp;textview</li>
<li>ViewStub&nbsp;stub&nbsp;=&nbsp;(ViewStub)&nbsp;findViewById(R.id.viewstub_demo_text);</li>
<li>stub.inflate();</li>
<li>TextView&nbsp;text&nbsp;=&nbsp;(TextView)&nbsp;findViewById(R.id.viewstub_demo_textview);</li>
<li>text.setText("The&nbsp;tree&nbsp;of&nbsp;liberty&nbsp;must&nbsp;be&nbsp;refreshed&nbsp;from&nbsp;time&nbsp;to&nbsp;time"&nbsp;+</li>
<li>"&nbsp;with&nbsp;the&nbsp;blood&nbsp;of&nbsp;patroits&nbsp;and&nbsp;tyrants!&nbsp;Freedom&nbsp;is&nbsp;nothing&nbsp;but&nbsp;"&nbsp;+</li>
<li>"a&nbsp;chance&nbsp;to&nbsp;be&nbsp;better!");</li>
<li>}&nbsp;else&nbsp;{</li>
<li>//&nbsp;to&nbsp;show&nbsp;image</li>
<li>//&nbsp;all&nbsp;you&nbsp;have&nbsp;to&nbsp;do&nbsp;is&nbsp;inflate&nbsp;the&nbsp;ViewStub&nbsp;for&nbsp;imageview</li>
<li>ViewStub&nbsp;stub&nbsp;=&nbsp;(ViewStub)&nbsp;findViewById(R.id.viewstub_demo_image);</li>
<li>stub.inflate();</li>
<li>ImageView&nbsp;image&nbsp;=&nbsp;(ImageView)&nbsp;findViewById(R.id.viewstub_demo_imageview);</li>
<li>image.setImageResource(R.drawable.happy_running_dog);</li>
<li>}</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>运行结果：</p>
<p><img referrerpolicy="no-referrer"src="http://hi.csdn.net/attachment/201110/15/0_1318692141FBNT.gif" /><img referrerpolicy="no-referrer"src="http://hi.csdn.net/attachment/201110/15/0_1318692154av4a.gif" /></p>
<p>使用的时候的注意事项：</p>
<p>1.<br />
某些布局属性要加在ViewStub而不是实际的布局上面，才会起作用，比如上面用的android:layout_margin*系列属性，如果加在<br />
TextView上面，则不会起作用，需要放在它的ViewStub上面才会起作用。而ViewStub的属性在inflate()后会都传给相应的布<br />
局。</p>
<p><strong>虽然很简单，但是感觉实际应用中比较少见</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z1wx19.html">美国usan数据库&mdash;&mdash;PDF提取</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql1mkk9.html">Java基础知识回顾</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g56kz8.html">10天学会phpWeChat&mdash;&mdash;第五天：实现新闻投稿功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qweze3q.html">QT5笔记：关闭应用程序和窗口的函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m101xq.html">lua字符匹配</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde7gej9.html">redis之lua脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/90myndj8.html">走进STM32世界之Hex程序烧写</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1ppe1q.html">jQuery serialize&lpar;&rpar;方法获取不到数据，alert结果为空</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ye6yr8.html">Java编程的逻辑 &lpar;51&rpar; - 剖析EnumSet</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1k6xq.html">C&num;单问号（&quest;）与双问号（&quest;&quest;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2501lxq.html">C&num;default关键字&lpar;泛型代码中的默认关键字&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g7pw6q.html">spring proxy-target-class</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1dl7l9.html">pip 国内源 配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjgkz79.html">Git在Eclipse中的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95geexzq.html">spring cloud服务发现注解之&commat;EnableDiscoveryClient与&commat;EnableEurekaClient区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/95go6pzq.html">从输入URL到页面加载的过程？由一道题完善自己的前端知识体系！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd16vj9.html">安卓4&period;2用adb 获取屏幕分辨率等信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2g6xpq.html">13&period;2&period;DataGrid增、删、改、查后台实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em11ox9.html">UVa 572 油田 &lpar;dfs&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/953jp2m8.html">prayer OJ M</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mejvlrq.html">sqlserver判断字符串是否是数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzmrl48.html">Learning from the CakePHP source code - Part I</a>
			</li>
						<li><a href="https://www.batexi.com/a/9503vzz8.html">12C RMAN 备份参考v1</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgnpw78.html">JQuery常用API   核心 效果   JQueryHTML   遍历   Event事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eymkye9.html">String中的&equals;&equals;与Empty</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk2gye8.html">LoadRunner参数值定义-摘自一米阳光</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdpoyy9.html">HomeBrew 安装 PHP7&period;1（开发笔记）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jklox8.html">C&num;中Invoke的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj1r0e9.html">zoj 1508 poj 1201 Intervals</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzm3pl8.html">git的使用&comma;将本地项目push到github上</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
